#include-once
;BASSCD 2.4 Visual Basic module
;Copyright (c) 2003-2008 Un4seen Developments Ltd.
;See the BASSCD.CHM file for more detailed documentation

;Additional error codes returned by BASS_ErrorGetCode
Global Const $BASS_ERROR_NOCD = 12 ;no CD in drive
Global Const $BASS_ERROR_CDTRACK = 13 ;invalid track number
Global Const $BASS_ERROR_NOTAUDIO = 17 ;not an audio track

;Additional BASS_SetConfig options
Global Const $BASS_CONFIG_CD_FREEOLD = 0x10200
Global Const $BASS_CONFIG_CD_RETRY = 0x10201
Global Const $BASS_CONFIG_CD_AUTOSPEED = 0x10202
Global Const $BASS_CONFIG_CD_SKIPERROR = 0x10203

;additional BASS_SetConfigPtr options
Global Const $BASS_CONFIG_CD_CDDB_SERVER = 0x10204

;BASS_CD_SetInterface options
Global Const $BASS_CD_IF_AUTO = 0
Global Const $BASS_CD_IF_SPTI = 1
Global Const $BASS_CD_IF_ASPI = 2
Global Const $BASS_CD_IF_WIO = 3
Global Const $BASS_CD_IF_LINUX = 4

Global Const $BASS_CD_INFO = 'long vendor;' & _ ;manufacturer
		'long product;' & _ ;model
		'long rev;' & _ ;revision
		'long letter;' & _ ;drive letter
		'long rwflags;' & _ ;read/write capability flags
		'long canopen;' & _ ;BASS_CD_DOOR_OPEN/CLOSE is supported?
		'long canlock;' & _ ;BASS_CD_DOOR_LOCK/UNLOCK is supported?
		'long maxspeed;' & _ ;max read speed (KB/s)
		'long cache;' & _ ;cache size (KB)
		'long cdtext;' ;can read CD-TEXT

;"rwflag" read capability flags
Global Const $BASS_CD_RWFLAG_READCDR = 1
Global Const $BASS_CD_RWFLAG_READCDRW = 2
Global Const $BASS_CD_RWFLAG_READCDRW2 = 4
Global Const $BASS_CD_RWFLAG_READDVD = 8
Global Const $BASS_CD_RWFLAG_READDVDR = 16
Global Const $BASS_CD_RWFLAG_READDVDRAM = 32
Global Const $BASS_CD_RWFLAG_READANALOG = 0x10000
Global Const $BASS_CD_RWFLAG_READM2F1 = 0x100000
Global Const $BASS_CD_RWFLAG_READM2F2 = 0x200000
Global Const $BASS_CD_RWFLAG_READMULTI = 0x400000
Global Const $BASS_CD_RWFLAG_READCDDA = 0x1000000
Global Const $BASS_CD_RWFLAG_READCDDASIA = 0x2000000
Global Const $BASS_CD_RWFLAG_READSUBCHAN = 0x4000000
Global Const $BASS_CD_RWFLAG_READSUBCHANDI = 0x8000000
Global Const $BASS_CD_RWFLAG_READISRC = 0x20000000
Global Const $BASS_CD_RWFLAG_READUPC = 0x40000000

;additional BASS_CD_StreamCreate/File flags
Global Const $BASS_CD_SUBCHANNEL = 0x200
Global Const $BASS_CD_SUBCHANNEL_NOHW = 0x400
Global Const $BASS_CD_C2ERRORS = 0x800

;additional CD sync types
Global Const $BASS_SYNC_CD_ERROR = 1000
Global Const $BASS_SYNC_CD_SPEED = 1002

;BASS_CD_Door actions
Global Const $BASS_CD_DOOR_CLOSE = 0
Global Const $BASS_CD_DOOR_OPEN = 1
Global Const $BASS_CD_DOOR_LOCK = 2
Global Const $BASS_CD_DOOR_UNLOCK = 3

;BASS_CD_GetID flags
Global Const $BASS_CDID_UPC = 1
Global Const $BASS_CDID_CDDB = 2
Global Const $BASS_CDID_CDDB2 = 3
Global Const $BASS_CDID_TEXT = 4
Global Const $BASS_CDID_CDPLAYER = 5
Global Const $BASS_CDID_MUSICBRAINZ = 6
Global Const $BASS_CDID_ISRC = 0x100 ;+ track #
Global Const $BASS_CDID_CDDB_QUERY = 0x200
Global Const $BASS_CDID_CDDB_READ = 0x201 ; + entry #
Global Const $BASS_CDID_CDDB_READ_CACHE = 0x2FF

;BASS_CD_GetTOC modes
Global Const $BASS_CD_TOC_TIME = 0x100

;TOC structures
Global Const $BASS_CD_TOC_TRACK = "BYTE res1;" & _
		"BYTE adrcon;" & _ ; // ADR + control
		"BYTE track;" & _ ; // track number
		"BYTE res2;" & _
		"BYTE hmsf[4];"; union:	BYTE[4]: start address (hours/minutes/seconds/frames); DWORD: start address (logical block address)

Global Const $BASS_CD_TOC = "WORD size;" & _ ;// size of TOC
		"BYTE first;" & _ ;// first track
		"BYTE last;" & _ ;// last track
		"BYTE BASS_CD_TOC_TRACK[800];" ; up to 100 tracks

;BASS_CD_TOC_TRACK "adrcon" flags
Global Const $BASS_CD_TOC_CON_PRE = 1
Global Const $BASS_CD_TOC_CON_COPY = 2
Global Const $BASS_CD_TOC_CON_DATA = 4

;CDDATAPROC "type" values
Global Const $BASS_CD_DATA_SUBCHANNEL = 0
Global Const $BASS_CD_DATA_C2 = 1

;BASS_CHANNELINFO type
Global Const $BASS_CTYPE_STREAM_CD = 0x10200