#include-once

; #INDEX# =======================================================================================================================
; Title .........: BassInc.au3
; Description ...: You can include the bass*.dll into your (compiled) script
; Author ........: eukalyptus
; Info ..........: the included DLLs are created in the Windows Tempfile directory (@TempDir) on StartUp and will be deleted OnExit
; Usage .........: Include BassInc.au3:       #include "BassInc.au3"
;                  Include needed Bass*.au3:  #include "Bass_X86.au3"
;                  StartUp dll:               _BASS_Startup(_BASS_INC_DLL($BASS_INC_DllBass))
;
;                  e.g.: to use 64bit version of BassEnc.dll:
;                                             #include "BassEnc_X64.au3"
;                                             _BASS_ENCODE_Startup(_BASS_INC_DLL($BASS_INC_DllBassEnc))
;
; ===============================================================================================================================

Global Const $BASS_INC_DllBass = "Bass"
Global Const $BASS_INC_DllBassAsio = "BassAsio"
Global Const $BASS_INC_DllBassCd = "BassCd"
Global Const $BASS_INC_DllBassEnc = "BassEnc"
Global Const $BASS_INC_DllBassExt = "BassExt"
Global Const $BASS_INC_DllBassFx = "BassFx"
Global Const $BASS_INC_DllBassMix = "BassMix"
Global Const $BASS_INC_DllBassSfx = "BassSfx"
Global Const $BASS_INC_DllBassTags = "BassTags"
Global Const $BASS_INC_DllBassVst = "BassVst"


Global $BASS_INC_FileBass = ""
Global $BASS_INC_FileBassAsio = ""
Global $BASS_INC_FileBassCd = ""
Global $BASS_INC_FileBassEnc = ""
Global $BASS_INC_FileBassExt = ""
Global $BASS_INC_FileBassFx = ""
Global $BASS_INC_FileBassMix = ""
Global $BASS_INC_FileBassSfx = ""
Global $BASS_INC_FileBassTags = ""
Global $BASS_INC_FileBassVst = ""

; #FUNCTION# ====================================================================================================================
; Name ..........: _BASS_INC_DLL
; Description ...: writes dll to windows temp directory
; Syntax ........: _BASS_INC_DLL($sDll)
; Parameters ....: -	$sDll	-	identifer of bass*
;                                     -   $BASS_INC_DllBass = "Bass"
;                                     -   $BASS_INC_DllBassAsio = "BassAsio"
;                                     -   $BASS_INC_DllBassCd = "BassCd"
;                                     -   $BASS_INC_DllBassEnc = "BassEnc"
;                                     -   $BASS_INC_DllBassExt = "BassExt"
;                                     -   $BASS_INC_DllBassFx = "BassFx"
;                                     -   $BASS_INC_DllBassMix = "BassMix"
;                                     -   $BASS_INC_DllBassSfx = "BassSfx"
;                                     -   $BASS_INC_DllBassTags = "BassTags"
;                                     -   $BASS_INC_DllBassVst = "BassVst"
; Return values .: Success      - Returns Path of created dll
;                  Failure      - Returns False and sets @ERROR
; Author ........: eukalyptus
; Modified ......:
; Remarks .......: You can include the bass*.dll into your (compiled) script
;				   the included DLLs are created in the Windows Tempfile directory (@TempDir) on StartUp and will be deleted OnExit
;				   Usage: Include BassInc.au3: #include "BassInc.au3"
;                  Include needed Bass*.au3: #include "Bass_X86.au3"
;                  StartUp dll: _BASS_Startup(_BASS_INC_DLL($BASS_INC_DllBass))
;
;                  e.g.: to use 64bit version of BassEnc.dll:
;                                             #include "BassEnc_X64.au3"
;                                             _BASS_ENCODE_Startup(_BASS_INC_DLL($BASS_INC_DllBassEnc))
; Related .......:
; Link ..........:
; Example .......:
; ===============================================================================================================================
Func _BASS_INC_DLL($sDll)
	Switch @AutoItX64
		Case True
			Switch $sDll
				Case "Bass"
					If Not IsDeclared("BASS_INC_DLL_BASS64") Then Return SetError(1, 0, "")
					$BASS_INC_FileBass = __BASS_INC_GetUniqueFileName(@TempDir & "\Bass.dll")
					__BASS_INC_CreateDll($BASS_INC_FileBass, Eval("BASS_INC_DLL_BASS64"))
					If Not @error Then OnAutoItExitRegister("__BASS_INC_DeleteBASS")
					Return $BASS_INC_FileBass
					;Case "BassAsio"
					;Case "BassCd"
				Case "BassEnc"
					If Not IsDeclared("BASS_INC_DLL_BASSENC64") Then Return SetError(1, 0, "")
					$BASS_INC_FileBassEnc = __BASS_INC_GetUniqueFileName(@TempDir & "\BassEnc.dll")
					__BASS_INC_CreateDll($BASS_INC_FileBassEnc, Eval("BASS_INC_DLL_BASSENC64"))
					If Not @error Then OnAutoItExitRegister("__BASS_INC_DeleteBASSENC")
					Return $BASS_INC_FileBassEnc
				Case "BassExt"
					If Not IsDeclared("BASS_INC_DLL_BASSEXT64") Then Return SetError(1, 0, "")
					$BASS_INC_FileBassExt = __BASS_INC_GetUniqueFileName(@TempDir & "\BassExt.dll")
					__BASS_INC_CreateDll($BASS_INC_FileBassExt, Eval("BASS_INC_DLL_BASSEXT64"))
					If Not @error Then OnAutoItExitRegister("__BASS_INC_DeleteBASSEXT")
					Return $BASS_INC_FileBassExt
				Case "BassFx"
					If Not IsDeclared("BASS_INC_DLL_BASSFX64") Then Return SetError(1, 0, "")
					$BASS_INC_FileBassFx = __BASS_INC_GetUniqueFileName(@TempDir & "\Bass_Fx.dll")
					__BASS_INC_CreateDll($BASS_INC_FileBassFx, Eval("BASS_INC_DLL_BASSFX64"))
					If Not @error Then OnAutoItExitRegister("__BASS_INC_DeleteBASSFX")
					Return $BASS_INC_FileBassFx
				Case "BassMix"
					If Not IsDeclared("BASS_INC_DLL_BASSMIX64") Then Return SetError(1, 0, "")
					$BASS_INC_FileBassMix = __BASS_INC_GetUniqueFileName(@TempDir & "\BassMix.dll")
					__BASS_INC_CreateDll($BASS_INC_FileBassMix, Eval("BASS_INC_DLL_BASSMIX64"))
					If Not @error Then OnAutoItExitRegister("__BASS_INC_DeleteBASSMIX")
					Return $BASS_INC_FileBassMix
					;Case "BassSfx"
					;Case "BassTags"
					;Case "BassVst"
			EndSwitch
		Case Else
			Switch $sDll
				Case "Bass"
					If Not IsDeclared("BASS_INC_DLL_BASS86") Then Return SetError(1, 0, "")
					$BASS_INC_FileBass = __BASS_INC_GetUniqueFileName(@TempDir & "\Bass.dll")
					__BASS_INC_CreateDll($BASS_INC_FileBass, Eval("BASS_INC_DLL_BASS86"))
					If Not @error Then OnAutoItExitRegister("__BASS_INC_DeleteBASS")
					Return $BASS_INC_FileBass
				Case "BassAsio"
					If Not IsDeclared("BASS_INC_DLL_BASSASIO86") Then Return SetError(1, 0, "")
					$BASS_INC_FileBassAsio = __BASS_INC_GetUniqueFileName(@TempDir & "\BassAsio.dll")
					__BASS_INC_CreateDll($BASS_INC_FileBassAsio, Eval("BASS_INC_DLL_BASSASIO86"))
					If Not @error Then OnAutoItExitRegister("__BASS_INC_DeleteBASSASIO")
					Return $BASS_INC_FileBassAsio
				Case "BassCd"
					If Not IsDeclared("BASS_INC_DLL_BASSCD86") Then Return SetError(1, 0, "")
					$BASS_INC_FileBassCd = __BASS_INC_GetUniqueFileName(@TempDir & "\BassCd.dll")
					__BASS_INC_CreateDll($BASS_INC_FileBassCd, Eval("BASS_INC_DLL_BASSCD86"))
					If Not @error Then OnAutoItExitRegister("__BASS_INC_DeleteBASSCD")
					Return $BASS_INC_FileBassCd
				Case "BassEnc"
					If Not IsDeclared("BASS_INC_DLL_BASSENC86") Then Return SetError(1, 0, "")
					$BASS_INC_FileBassEnc = __BASS_INC_GetUniqueFileName(@TempDir & "\BassEnc.dll")
					__BASS_INC_CreateDll($BASS_INC_FileBassEnc, Eval("BASS_INC_DLL_BASSENC86"))
					If Not @error Then OnAutoItExitRegister("__BASS_INC_DeleteBASSENC")
					Return $BASS_INC_FileBassEnc
				Case "BassExt"
					If Not IsDeclared("BASS_INC_DLL_BASSEXT86") Then Return SetError(1, 0, "")
					$BASS_INC_FileBassExt = __BASS_INC_GetUniqueFileName(@TempDir & "\BassExt.dll")
					__BASS_INC_CreateDll($BASS_INC_FileBassExt, Eval("BASS_INC_DLL_BASSEXT86"))
					If Not @error Then OnAutoItExitRegister("__BASS_INC_DeleteBASSEXT")
					Return $BASS_INC_FileBassExt
				Case "BassFx"
					If Not IsDeclared("BASS_INC_DLL_BASSFX86") Then Return SetError(1, 0, "")
					$BASS_INC_FileBassFx = __BASS_INC_GetUniqueFileName(@TempDir & "\Bass_fx.dll")
					__BASS_INC_CreateDll($BASS_INC_FileBassFx, Eval("BASS_INC_DLL_BASSFX86"))
					If Not @error Then OnAutoItExitRegister("__BASS_INC_DeleteBASSFX")
					Return $BASS_INC_FileBassFx
				Case "BassMix"
					If Not IsDeclared("BASS_INC_DLL_BASSMIX86") Then Return SetError(1, 0, "")
					$BASS_INC_FileBassMix = __BASS_INC_GetUniqueFileName(@TempDir & "\BassMix.dll")
					__BASS_INC_CreateDll($BASS_INC_FileBassMix, Eval("BASS_INC_DLL_BASSMIX86"))
					If Not @error Then OnAutoItExitRegister("__BASS_INC_DeleteBASSMIX")
					Return $BASS_INC_FileBassMix
				Case "BassSfx"
					If Not IsDeclared("BASS_INC_DLL_BASSSFX86") Then Return SetError(1, 0, "")
					$BASS_INC_FileBassSfx = __BASS_INC_GetUniqueFileName(@TempDir & "\Bass_sfx.dll")
					__BASS_INC_CreateDll($BASS_INC_FileBassSfx, Eval("BASS_INC_DLL_BASSSFX86"))
					If Not @error Then OnAutoItExitRegister("__BASS_INC_DeleteBASSSFX")
					Return $BASS_INC_FileBassSfx
				Case "BassTags"
					If Not IsDeclared("BASS_INC_DLL_BASSTAGS86") Then Return SetError(1, 0, "")
					$BASS_INC_FileBassTags = __BASS_INC_GetUniqueFileName(@TempDir & "\BassTags.dll")
					__BASS_INC_CreateDll($BASS_INC_FileBassTags, Eval("BASS_INC_DLL_BASSTAGS86"))
					If Not @error Then OnAutoItExitRegister("__BASS_INC_DeleteBASSTAGS")
					Return $BASS_INC_FileBassTags
				Case "BassVst"
					If Not IsDeclared("BASS_INC_DLL_BASSVST86") Then Return SetError(1, 0, "")
					$BASS_INC_FileBassVst = __BASS_INC_GetUniqueFileName(@TempDir & "\Bass_vst.dll")
					__BASS_INC_CreateDll($BASS_INC_FileBassVst, Eval("BASS_INC_DLL_BASSVST86"))
					If Not @error Then OnAutoItExitRegister("__BASS_INC_DeleteBASSVST")
					Return $BASS_INC_FileBassVst
			EndSwitch
	EndSwitch
EndFunc   ;==>_BASS_INC_DLL



; ===============================================================================================================================
; Internal
; ===============================================================================================================================

Func __BASS_INC_CreateDll($sFile, $bDLL)
	Local $aPath = StringRegExp($sFile, '(.+\\)(.+)(\..+)', 3)
	DirCreate($aPath[0])
	If @error Then Return SetError(1, 0, 0)
	Local $hFile = FileOpen($sFile, 18)
	If @error Then Return SetError(1, 0, 0)
	FileWrite($hFile, $bDLL)
	If @error Then Return SetError(1, 0, 0)
	FileClose($hFile)
EndFunc   ;==>__BASS_INC_CreateDll


Func __BASS_INC_DllClose($sDll)
	If IsDeclared($sDll) And Eval($sDll) > 0 Then
		DllClose(Eval($sDll))
		Assign($sDll, -1)
	EndIf
EndFunc   ;==>__BASS_INC_DllClose


Func __BASS_INC_DeleteDll($sFile)
	Local $aPath = StringRegExp($sFile, '(.+\\)(.+)(\..+)', 3)
	If @error Then Return SetError(1, 0, 0)
	__BASS_INC_DllClose("_ghBassASIODll")
	__BASS_INC_DllClose("_ghBassCDDll")
	__BASS_INC_DllClose("_ghBassEncDll")
	__BASS_INC_DllClose("_ghBassFXDll")
	__BASS_INC_DllClose("_ghBassMixDll")
	__BASS_INC_DllClose("_ghBassSFXDll")
	__BASS_INC_DllClose("_ghBassTagsDll")
	__BASS_INC_DllClose("_ghbassVSTDll")
	__BASS_INC_DllClose("_ghBassEXTDll")
	__BASS_INC_DllClose("_ghBassDll")
	If StringLen($aPath[0]) > StringLen(@TempDir) And StringInStr($aPath[0], @TempDir) Then DirRemove($aPath[0], 1)
EndFunc   ;==>__BASS_INC_DeleteDll

Func __BASS_INC_DeleteBASS()
	__BASS_INC_DeleteDll($BASS_INC_FileBass)
EndFunc   ;==>__BASS_INC_DeleteBASS
Func __BASS_INC_DeleteBassAsio()
	__BASS_INC_DeleteDll($BASS_INC_FileBassAsio)
EndFunc   ;==>__BASS_INC_DeleteBassAsio
Func __BASS_INC_DeleteBassCd()
	__BASS_INC_DeleteDll($BASS_INC_FileBassCd)
EndFunc   ;==>__BASS_INC_DeleteBassCd
Func __BASS_INC_DeleteBassEnc()
	__BASS_INC_DeleteDll($BASS_INC_FileBassEnc)
EndFunc   ;==>__BASS_INC_DeleteBassEnc
Func __BASS_INC_DeleteBassExt()
	__BASS_INC_DeleteDll($BASS_INC_FileBassExt)
EndFunc   ;==>__BASS_INC_DeleteBassExt
Func __BASS_INC_DeleteBassFx()
	__BASS_INC_DeleteDll($BASS_INC_FileBassFx)
EndFunc   ;==>__BASS_INC_DeleteBassFx
Func __BASS_INC_DeleteBassMix()
	__BASS_INC_DeleteDll($BASS_INC_FileBassMix)
EndFunc   ;==>__BASS_INC_DeleteBassMix
Func __BASS_INC_DeleteBassSfx()
	__BASS_INC_DeleteDll($BASS_INC_FileBassSfx)
EndFunc   ;==>__BASS_INC_DeleteBassSfx
Func __BASS_INC_DeleteBassTags()
	__BASS_INC_DeleteDll($BASS_INC_FileBassTags)
EndFunc   ;==>__BASS_INC_DeleteBassTags
Func __BASS_INC_DeleteBassVst()
	__BASS_INC_DeleteDll($BASS_INC_FileBassVst)
EndFunc   ;==>__BASS_INC_DeleteBassVst


; #INTERNAL# ====================================================================================================================
; Name ..........: __BASS_INC_GetUniqueFileName
; Description ...: Wenn der Dateiname bereits existiert wird ein Zhler in Form von: "_(1)" an den Dateinamen angehngt.
; Syntax ........: __BASS_INC_GetUniqueFileName($sPath)
; Parameters ....: $sPath = kompletter Pfad der Datei
; Return values .: Success	- der (neue) Dateiname
;                  Failure	- @error = 1 (Pfad falsch angegeben)
; Author ........: Oscar (www.autoit.de)
; Modified ......: eukalyptus (www.autoit.de)
; Remarks .......:
; Related .......:
; Link ..........:
; Example .......:
; ===============================================================================================================================
Func __BASS_INC_GetUniqueFileName($sPath)
	Local $aPath, $sSubPath = 'BASSINC\', $iCount = 0
	$aPath = StringRegExp($sPath, '(.+\\)(.+)(\..+)', 3)
	If @error Then Return SetError(1, 0, 0)
	While FileExists($aPath[0] & $sSubPath)
		$iCount += 1
		$sSubPath = 'BASSINC' & $iCount & '\'
	WEnd
	Return $aPath[0] & $sSubPath & $aPath[1] & $aPath[2]
EndFunc   ;==>__BASS_INC_GetUniqueFileName