#include-once
; ===============================================================================================================================
; Additional config options
; ===============================================================================================================================
Global Const $BASS_CONFIG_MIDI_COMPACT = 0x10400
Global Const $BASS_CONFIG_MIDI_VOICES = 0x10401
Global Const $BASS_CONFIG_MIDI_AUTOFONT = 0x10402

; ===============================================================================================================================
; Additional BASS_SetConfigPtr options
; ===============================================================================================================================
Global Const $BASS_CONFIG_MIDI_DEFFONT = 0x10403

; ===============================================================================================================================
; Additional sync types
; ===============================================================================================================================
Global Const $BASS_SYNC_MIDI_MARKER = 0x10000
Global Const $BASS_SYNC_MIDI_CUE = 0x10001
Global Const $BASS_SYNC_MIDI_LYRIC = 0x10002
Global Const $BASS_SYNC_MIDI_TEXT = 0x10003
Global Const $BASS_SYNC_MIDI_EVENT = 0x10004
Global Const $BASS_SYNC_MIDI_TICK = 0x10005
Global Const $BASS_SYNC_MIDI_TIMESIG = 0x10006
Global Const $BASS_SYNC_MIDI_KEYSIG = 0x10007

; ===============================================================================================================================
; Additional BASS_MIDI_StreamCreateFile/etc flags
; ===============================================================================================================================
Global Const $BASS_MIDI_DECAYEND = 0x1000
Global Const $BASS_MIDI_NOFX = 0x2000
Global Const $BASS_MIDI_DECAYSEEK = 0x4000

; ===============================================================================================================================
; Marker types
; ===============================================================================================================================
Global Const $BASS_MIDI_MARK_MARKER = 0;marker events
Global Const $BASS_MIDI_MARK_CUE = 1;cue events
Global Const $BASS_MIDI_MARK_LYRIC = 2;lyric events
Global Const $BASS_MIDI_MARK_TEXT = 3;text events
Global Const $BASS_MIDI_MARK_TIMESIG = 4;time signature
Global Const $BASS_MIDI_MARK_KEYSIG = 5;key signature

; ===============================================================================================================================
; MIDI events
; ===============================================================================================================================
Global Const $MIDI_EVENT_NOTE = 1
Global Const $MIDI_EVENT_PROGRAM = 2
Global Const $MIDI_EVENT_CHANPRES = 3
Global Const $MIDI_EVENT_PITCH = 4
Global Const $MIDI_EVENT_PITCHRANGE = 5
Global Const $MIDI_EVENT_DRUMS = 6
Global Const $MIDI_EVENT_FINETUNE = 7
Global Const $MIDI_EVENT_COARSETUNE = 8
Global Const $MIDI_EVENT_MASTERVOL = 9
Global Const $MIDI_EVENT_BANK = 10
Global Const $MIDI_EVENT_MODULATION = 11
Global Const $MIDI_EVENT_VOLUME = 12
Global Const $MIDI_EVENT_PAN = 13
Global Const $MIDI_EVENT_EXPRESSION = 14
Global Const $MIDI_EVENT_SUSTAIN = 15
Global Const $MIDI_EVENT_SOUNDOFF = 16
Global Const $MIDI_EVENT_RESET = 17
Global Const $MIDI_EVENT_NOTESOFF = 18
Global Const $MIDI_EVENT_PORTAMENTO = 19
Global Const $MIDI_EVENT_PORTATIME = 20
Global Const $MIDI_EVENT_PORTANOTE = 21
Global Const $MIDI_EVENT_MODE = 22
Global Const $MIDI_EVENT_REVERB = 23
Global Const $MIDI_EVENT_CHORUS = 24
Global Const $MIDI_EVENT_CUTOFF = 25
Global Const $MIDI_EVENT_RESONANCE = 26
Global Const $MIDI_EVENT_RELEASE = 27
Global Const $MIDI_EVENT_ATTACK = 28
Global Const $MIDI_EVENT_REVERB_MACRO = 30
Global Const $MIDI_EVENT_CHORUS_MACRO = 31
Global Const $MIDI_EVENT_REVERB_TIME = 32
Global Const $MIDI_EVENT_REVERB_DELAY = 33
Global Const $MIDI_EVENT_REVERB_LOCUTOFF = 34
Global Const $MIDI_EVENT_REVERB_HICUTOFF = 35
Global Const $MIDI_EVENT_REVERB_LEVEL = 36
Global Const $MIDI_EVENT_CHORUS_DELAY = 37
Global Const $MIDI_EVENT_CHORUS_DEPTH = 38
Global Const $MIDI_EVENT_CHORUS_RATE = 39
Global Const $MIDI_EVENT_CHORUS_FEEDBACK = 40
Global Const $MIDI_EVENT_CHORUS_LEVEL = 41
Global Const $MIDI_EVENT_CHORUS_REVERB = 42
Global Const $MIDI_EVENT_DRUM_FINETUNE = 50
Global Const $MIDI_EVENT_DRUM_COARSETUNE = 51
Global Const $MIDI_EVENT_DRUM_PAN = 52
Global Const $MIDI_EVENT_DRUM_REVERB = 53
Global Const $MIDI_EVENT_DRUM_CHORUS = 54
Global Const $MIDI_EVENT_DRUM_CUTOFF = 55
Global Const $MIDI_EVENT_DRUM_RESONANCE = 56
Global Const $MIDI_EVENT_DRUM_LEVEL = 57
Global Const $MIDI_EVENT_SOFT = 60
Global Const $MIDI_EVENT_SYSTEM = 61
Global Const $MIDI_EVENT_TEMPO = 62
Global Const $MIDI_EVENT_SCALETUNING = 63
Global Const $MIDI_EVENT_MIXLEVEL = 0x10000
Global Const $MIDI_EVENT_TRANSPOSE = 0x10001
Global Const $MIDI_EVENT_SYSTEMEX = 0x10002
Global Const $MIDI_SYSTEM_DEFAULT = 0
Global Const $MIDI_SYSTEM_GM1 = 1
Global Const $MIDI_SYSTEM_GM2 = 2
Global Const $MIDI_SYSTEM_XG = 3
Global Const $MIDI_SYSTEM_GS = 4

; ===============================================================================================================================
; BASS_MIDI_StreamEvents modes
; ===============================================================================================================================
Global Const $BASS_MIDI_EVENTS_STRUCT = 0
Global Const $BASS_MIDI_EVENTS_RAW = 0x10000
Global Const $BASS_MIDI_EVENTS_SYNC = 0x1000000

; ===============================================================================================================================
; BASS_CHANNELINFO type
; ===============================================================================================================================
Global Const $BASS_CTYPE_STREAM_MIDI = 0x10d00

; ===============================================================================================================================
; Additional attributes
; ===============================================================================================================================
Global Const $BASS_ATTRIB_MIDI_PPQN = 0x12000
Global Const $BASS_ATTRIB_MIDI_CPU = 0x12001
Global Const $BASS_ATTRIB_MIDI_CHANS = 0x12002
Global Const $BASS_ATTRIB_MIDI_VOICES = 0x12003
Global Const $BASS_ATTRIB_MIDI_TRACK_VOL = 0x12100;+ track #

; ===============================================================================================================================
; Additional tag type
; ===============================================================================================================================
Global Const $BASS_TAG_MIDI_TRACK = 0x11000;+ track #, track text : array of null-terminated ANSI strings

; ===============================================================================================================================
; BASS_ChannelGetLength/GetPosition/SetPosition mode
; ===============================================================================================================================
Global Const $BASS_POS_MIDI_TICK = 2;tick position


Global Const $BASS_MIDI_FONT = 'DWord font;' & _ ;soundfont
		'Long preset;' & _ ;preset number (-1=all)
		'Long bank;'

Global Const $BASS_MIDI_FONTINFO = 'Str name;' & _
		'Str copyright;' & _
		'Str comment;' & _
		'DWORD presets;' & _ ;number of presets/instruments
		'DWORD samsize;' & _ ;total size (in bytes) of the sample data
		'DWORD samload;' & _ ;amount of sample data currently loaded
		'DWORD samtype;';sample format (CTYPE) if packed

Global Const $BASS_MIDI_MARK = 'DWORD track;' & _ ;track containing marker
		'DWORD pos;' & _ ;marker position
		'Str text;';marker text

Global Const $BASS_MIDI_EVENT = 'DWORD event;' & _ ;MIDI_EVENT_xxx
		'DWORD param;' & _
		'DWORD chan;' & _
		'DWORD tick;' & _ ;event position (ticks)
		'DWORD pos;';event position (bytes)

Global Const $BASS_MIDI_DEVICEINFO = 'Str name;' & _
		'DWord description;' & _
		'DWord id;' & _
		'DWord flags;'